"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const backfill = __importStar(require("backfill/lib/api"));
const path_1 = __importDefault(require("path"));
const hashes = {};
const cacheHits = {};
exports.cacheHits = cacheHits;
async function computeHash(info) {
    const cwd = path_1.default.dirname(info.packageJsonPath);
    const logger = backfill.makeLogger("silly", process.stdout, process.stderr);
    const name = require(path_1.default.join(cwd, "package.json")).name;
    logger.setName(name);
    logger.setMode("verbose", "verbose");
    // TODO: "hi" here needs to account for file contents of important config files & cmd & workspace root
    const hash = await backfill.computeHash(cwd, "hi", logger);
    hashes[cwd] = hash;
}
exports.computeHash = computeHash;
async function fetchBackfill(info) {
    const cwd = path_1.default.dirname(info.packageJsonPath);
    const logger = backfill.makeLogger("silly", process.stdout, process.stderr);
    const hash = hashes[cwd];
    const cacheHit = await backfill.fetch(cwd, hash, logger);
    cacheHits[info.name] = cacheHit;
}
exports.fetchBackfill = fetchBackfill;
async function putBackfill(info) {
    const cwd = path_1.default.dirname(info.packageJsonPath);
    if (cacheHits[info.name]) {
        return;
    }
    const logger = backfill.makeLogger("silly", process.stdout, process.stderr);
    const hash = hashes[cwd];
    await backfill.put(cwd, hash, logger);
}
exports.putBackfill = putBackfill;
