"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const internalDeps_1 = require("../monorepo/internalDeps");
const taskId_1 = require("../task/taskId");
function injectCacheTasks(context) {
    var _a;
    const { allPackages, taskDepsMap, command } = context;
    // TODO: figure out how to do inproc stuff like computehash, fetch and put without having to resort to hardcoded stuff
    // implied: {computeHash: [^computeHash], fetch: [computeHash], put: [all tasks in tasks]}
    for (const [pkg, info] of Object.entries(allPackages)) {
        const dependentPkgs = internalDeps_1.getInternalDeps(info, allPackages);
        // add _computeHash
        const computeHashTaskId = taskId_1.getTaskId(pkg, "_computeHash");
        for (const depPkg of dependentPkgs) {
            (_a = taskDepsMap
                .get(computeHashTaskId)) === null || _a === void 0 ? void 0 : _a.push(taskId_1.getTaskId(depPkg, "_computeHash"));
        }
        // add _fetch
        const fetchTaskId = taskId_1.getTaskId(pkg, "_fetch");
        taskDepsMap.set(fetchTaskId, [computeHashTaskId]);
        if (info.scripts && info.scripts[command]) {
            // add _put
            const putTaskId = taskId_1.getTaskId(pkg, "_put");
            taskDepsMap.set(putTaskId, [taskId_1.getTaskId(pkg, command)]);
        }
    }
}
exports.injectCacheTasks = injectCacheTasks;
