"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const paths_1 = require("../paths");
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const infoFromPackageJson_1 = require("./infoFromPackageJson");
const workspaces_1 = require("./workspaces");
function getPackageInfos(cwd) {
    const packageJsonFiles = workspaces_1.getAllPackageJsonFiles(cwd);
    const gitRoot = paths_1.findGitRoot(cwd);
    const packageInfos = {};
    if (packageJsonFiles && packageJsonFiles.length > 0) {
        packageJsonFiles.forEach((packageJsonPath) => {
            try {
                const packageJsonFullPath = path_1.default.join(gitRoot, packageJsonPath);
                const packageJson = JSON.parse(fs_1.default.readFileSync(packageJsonFullPath, "utf-8"));
                packageInfos[packageJson.name] = infoFromPackageJson_1.infoFromPackageJson(packageJson, packageJsonFullPath);
            }
            catch (e) {
                // Pass, the package.json is invalid
                console.warn(`Invalid package.json file detected ${packageJsonPath}: `, e);
            }
        });
        return packageInfos;
    }
    return {};
}
exports.getPackageInfos = getPackageInfos;
