"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const taskId_1 = require("../task/taskId");
function hrtimeToSec(hrtime) {
    return (hrtime[0] + hrtime[1] / 1e9).toFixed(2);
}
function hr() {
    console.log("----------------------------------------------");
}
async function reportSummary(context) {
    const { command, measures } = context;
    hr();
    if (measures.failedTask) {
        const [pkg, task] = taskId_1.getPackageTaskFromId(measures.failedTask);
        console.error(`ERROR DETECTED IN ${pkg} ${task}`);
        hr();
    }
    console.log(measures.taskStats
        .map((stats) => {
        const [pkg, task] = taskId_1.getPackageTaskFromId(stats.taskId);
        return `[${pkg} - ${task}] took ${hrtimeToSec(stats.duration)}s`;
    })
        .join("\n"));
    hr();
    console.log(`The command "${command}" took a total of ${hrtimeToSec(measures.duration)}s to complete`);
}
exports.reportSummary = reportSummary;
