"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const p_graph_1 = __importDefault(require("p-graph"));
const cacheTasks_1 = require("../cache/cacheTasks");
const performance_1 = require("../performance");
async function runTasks(context) {
    const { command, profiler } = context;
    context.measures.start = process.hrtime();
    console.log(`Executing command "${command}"`);
    cacheTasks_1.generateCacheTasks(context);
    try {
        await p_graph_1.default(context.tasks, context.taskDepsGraph).run();
    }
    catch (_a) {
        // passthru
    }
    profiler.output();
    context.measures.duration = process.hrtime(context.measures.start);
    await performance_1.reportSummary(context);
}
exports.runTasks = runTasks;
